//    RDS PC software main file 
//
// =====================================================
//  Description
//    This file include main functions
//       of RDS USB PC software using : AVR USB driver  by OBJECTIVE DEVELOPMENT Software GmbH 
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
//=======================================
// Author : G.Laroche www.g.laroche.free.fr
//=======================================
// History:
// 09/07/06    V1.0
//       create
//=======================================

#include <windows.h>
#include "RdsUsbMain.h"

/* include driver usb for RDS application */
#include "usbInterface.h"
#include "rds_usb.h"
#include "RdsUsbDriver.h"


/* local define */

#define RDSUSB_READ_BOARD 1  /* set to 1 for reading board value (0 is only for debug purpose)*/


#define RDSUSB_SIZE_NB_PARAM 43 /*  43 edit field  */

/* static data */

static char RdsUsbStringParam[RDSUSB_SIZE_RTXT+1];   /* max size +1 */
static char RdsUsbStringName[RDSUSB_SIZE_RTXT+1];   /* max size +1 */
static T_R_DataMainEdit DataEdit[RDSUSB_SIZE_NB_PARAM];
static int OffsetAF0; /*index of first AF in DataEdit array */
usb_dev_handle  * UsbRDSBoard;

/* Declare WindowsProcedure */
LRESULT CALLBACK WindowProcedure(HWND, UINT, WPARAM, LPARAM);
/* Make the classname into a global variable */
char szClassName[] = "RDS USB coder";
HINSTANCE hThisInstance;


int InitDataEdit(void)
{
   int Index,IndexDataEdit;
   int Result=0;
   
   for (Index=0; Index<RDSUSB_SIZE_NB_PARAM;Index++)
   {
      strcpy(DataEdit[Index].OldString,"");
   }

   #if RDSUSB_READ_BOARD
   Result = usbOpenDevice(&UsbRDSBoard, RDS_USB_VENDOR,RDS_USB_VENDOR_NAME, RDS_USB_PRODUCT, RDS_USB_VENDOR_DEVICE);
   #endif


   /* if OK , processing following init */
   if (Result == 0)
   {

   
   /* RAM data */
   /************/
   IndexDataEdit=0;
   
   /* PS Name */
   DataEdit[IndexDataEdit].IdEdit=IDC_EDTPS;
   DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_UPDATE_PS_1;
   #if RDSUSB_READ_BOARD
     RdsUsbReadPSRam(UsbRDSBoard,DataEdit[IndexDataEdit].OldString);
   #endif
   IndexDataEdit++;  

   /* RT */
   DataEdit[IndexDataEdit].IdEdit=IDC_EDTRT;
   DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_UPDATE_RT_0;
   #if RDSUSB_READ_BOARD
     RdsUsbReadRTRam(UsbRDSBoard,DataEdit[IndexDataEdit].OldString);
   #endif
   IndexDataEdit++;  

   /* PTY */
   DataEdit[IndexDataEdit].IdEdit=IDC_EDTPTY;
   DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_UPDATE_PTY;
   #if RDSUSB_READ_BOARD
     RdsUsbReadPTY_TP_TA_MS_DI(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,RDS_USB_READ_PTY);
   #endif
   IndexDataEdit++;  

   /* TP */
   DataEdit[IndexDataEdit].IdEdit=IDC_EDTTP;
   DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_UPDATE_TP;
   #if RDSUSB_READ_BOARD
     RdsUsbReadPTY_TP_TA_MS_DI(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,RDS_USB_READ_TP);
   #endif
   IndexDataEdit++;  
   
   /* TA */
   DataEdit[IndexDataEdit].IdEdit=IDC_EDTTA;
   DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_UPDATE_TA;
   #if RDSUSB_READ_BOARD
     RdsUsbReadPTY_TP_TA_MS_DI(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,RDS_USB_READ_TA);
   #endif
   IndexDataEdit++;  
   
   /* MS */
   DataEdit[IndexDataEdit].IdEdit=IDC_EDTMS;
   DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_UPDATE_MS;
   #if RDSUSB_READ_BOARD
     RdsUsbReadPTY_TP_TA_MS_DI(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,RDS_USB_READ_MS);
   #endif
   IndexDataEdit++;  
   
   /* DI */
   DataEdit[IndexDataEdit].IdEdit=IDC_EDTDI;
   DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_UPDATE_DI;
   #if RDSUSB_READ_BOARD
     RdsUsbReadPTY_TP_TA_MS_DI(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,RDS_USB_READ_DI);
   #endif
   IndexDataEdit++;  

   /* EEPROM data */
   /***************/
   
   /* PS Name */
   DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2PS;
   DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_PS_1;
   #if RDSUSB_READ_BOARD
     RdsUsbReadPSE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString);
   #endif
   IndexDataEdit++;  

   /* RT */
   DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2RT;
   DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_RT_0;
   #if RDSUSB_READ_BOARD
     RdsUsbReadRTE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString);
   #endif
   IndexDataEdit++;  

   /* PTY */
   DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2PTY;
   DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_PTY;
   #if RDSUSB_READ_BOARD
     RdsUsbReadPTY_TP_TA_MS_DI(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,RDS_USB_READ_E2P_PTY);
   #endif
   IndexDataEdit++;  

   /* TP */
   DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2TP;
   DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_TP;
   #if RDSUSB_READ_BOARD
     RdsUsbReadPTY_TP_TA_MS_DI(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,RDS_USB_READ_E2P_TP);
   #endif
   IndexDataEdit++;  
   
   /* TA */
   DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2TA;
   DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_TA;
   #if RDSUSB_READ_BOARD
     RdsUsbReadPTY_TP_TA_MS_DI(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,RDS_USB_READ_E2P_TA);
   #endif
   IndexDataEdit++;  
   
   /* MS */
   DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2MS;
   DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_MS;
   #if RDSUSB_READ_BOARD
     RdsUsbReadPTY_TP_TA_MS_DI(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,RDS_USB_READ_E2P_MS);
   #endif
   IndexDataEdit++;  
   
   /* DI */
   DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2DI;
   DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_DI;
   #if RDSUSB_READ_BOARD
     RdsUsbReadPTY_TP_TA_MS_DI(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,RDS_USB_READ_E2P_DI);
   #endif
   IndexDataEdit++;  

   /* PI code*/
   DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2PI;
   DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_PICODE;
   #if RDSUSB_READ_BOARD
     RdsUsbReadPIE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString);
   #endif
   IndexDataEdit++;  

   /* NBAF */
   DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2NAF;
   DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_NA;
   #if RDSUSB_READ_BOARD
     RdsUsbReadNAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString);
   #endif
   IndexDataEdit++;  

   Index=0;
   /* AF 00*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF00;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       OffsetAF0=IndexDataEdit;
       Index++;
       IndexDataEdit++;  
   /* AF 01*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF01;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 02*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF02;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 03*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF03;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 04*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF04;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 05*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF05;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 06*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF06;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 07*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF07;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 08*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF08;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 09*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF09;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 10*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF10;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 11*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF11;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 12*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF12;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 13*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF13;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 14*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF14;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 15*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF15;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 16*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF16;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 17*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF17;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 18*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF18;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 19*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF19;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 20*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF20;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 21*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF21;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 22*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF22;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 23*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF23;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
   /* AF 24*/
       DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2AF24;
       DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_STORE_AF;
       #if RDSUSB_READ_BOARD
         RdsUsbReadAFE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString,Index);
       #endif
       Index++;
       IndexDataEdit++;  
 
   /* 2A group */
   DataEdit[IndexDataEdit].IdEdit=IDC_EDT2A;
   DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_CONFIG_2A;
   #if RDSUSB_READ_BOARD
       RdsUsbRead2AE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString);
   #endif
   IndexDataEdit++; 
    
   /* stereo */ 
   DataEdit[IndexDataEdit].IdEdit=IDC_EDT_E2STEREO;
   DataEdit[IndexDataEdit].IdRdsFunction=RDS_USB_CONFIG_STEREO;
   #if RDSUSB_READ_BOARD
       RdsUsbReadSTE2p(UsbRDSBoard,DataEdit[IndexDataEdit].OldString);
   #endif
   IndexDataEdit++;  

   if (IndexDataEdit !=RDSUSB_SIZE_NB_PARAM)
   {
      printf("ERREUR InitDataEdit : IndexDataEdit=%d\r\n", IndexDataEdit);
   }


   }
   return(Result);   
}

/* copy all edit field with oldString for init display */
void InitOldDataEdit(HWND hDlg)
{
   int i;

   for(i=0;i<RDSUSB_SIZE_NB_PARAM;i++)
   {
      SetDlgItemText(hDlg,DataEdit[i].IdEdit,DataEdit[i].OldString);
   }
}

/* compare all edit field  between OldString and NewString  */
void CheckNewDataEdit(HWND hDlg)
{
   int i;

   for(i=0;i<RDSUSB_SIZE_NB_PARAM;i++)
   {
      if (strcmp(DataEdit[i].NewString,DataEdit[i].OldString) !=0)
      {
         if (DataEdit[i].IdRdsFunction != RDS_USB_STORE_AF)
         {
             RdsUsbWriteDataEdit(UsbRDSBoard,DataEdit[i].IdRdsFunction,DataEdit[i].NewString);
         }
         else
         {
             RdsUsbWriteAFE2p(UsbRDSBoard,DataEdit[i].NewString,i-OffsetAF0);
         }
         /* copy NewString to OldString for next compare */
         strcpy(DataEdit[i].OldString,DataEdit[i].NewString);
      }
   }
}


/* copy all edit field into NewString after user edit */
void ReadNewDataEdit(HWND hDlg)
{
   int i;

   for(i=0;i<RDSUSB_SIZE_NB_PARAM;i++)
   {
      GetDlgItemText(hDlg,DataEdit[i].IdEdit,DataEdit[i].NewString,NB_SIZE_DATA_EDIT_STRING);
   }
}


// Mesage handler for RDSDialogPS box.
LRESULT CALLBACK MainDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
		{
		   InitOldDataEdit(hDlg);
           return TRUE;
        }

		case WM_COMMAND:
		
			switch (LOWORD(wParam))
			{
			case IDC_OK:
    			{
    			    /* read all new data */
    			    ReadNewDataEdit(hDlg);
    			    CheckNewDataEdit(hDlg);
    		        //MessageBox (hDlg,"OK","USB RDS coder",MB_ICONINFORMATION | MB_OK); 
    
    				return TRUE;
    			}
 			case IDC_CANCEL:
                  /* write all old data to cancel new value */
 			      InitOldDataEdit(hDlg);
 
 			    return TRUE;
 			    
 			case IDC_RESET:
                  if (MessageBox (hDlg,"Reset EEPROM to default value ?" ,"USB RDS coder",MB_OKCANCEL) ==IDOK)
                  {
                      RdsUsbResetE2p(UsbRDSBoard);
                      MessageBox (hDlg,"EEPROM RDS reinitialised" ,"USB RDS coder",MB_ICONINFORMATION | MB_OK);
                      EndDialog(hDlg,IDC_RESET);
                  }
 			    return TRUE;
 			    
 			    
 			case IDC_HELPABOUT:
                   MessageBox (hDlg,
                   "RDS USB coder V1.2 08/2007 \r\nhttp://www.g.laroche.free.fr\r\n \
                   RAM section is current RDS data\r\n \
                   EEPROM section correspond to default value for power on\r\n\
                   mono/stereo : select clock used internal/external\r\n\
                   2A Group: select radiotext usage : 0=no radiotext / N:2A group send every N 0A groups \r\n\
                   Note:EEPROM PSNAME and radiotext change automatically RAM associate data \r\n\
                   PI= Program Identification code\r\n\
                   PSNAME = Program Service Name\r\n\
                   PTY = Program type\r\n\
                   MS = Music/speech\r\n\
                   DI = Decoder Information\r\n\
                   TP = Traffic Possible \r\n\
                   TA = Traffic Announcement \r\n\
                   AF = Alternate Frequency" ,
                   "RDS USB coder  version 1.2 ", 
                   MB_ICONINFORMATION | MB_OK);
 			    return TRUE;
            case IDC_QUIT:
                  EndDialog(hDlg,IDC_QUIT);
                return TRUE;
            } 	
            break;	
            
             	
        case WM_CLOSE:
            EndDialog(hDlg,IDC_QUIT);
            return TRUE;
	}
    return FALSE;
}


int WINAPI WinMain(HINSTANCE hThisInstance, HINSTANCE hPrevInstance, LPSTR lpszArgument, int nFunsterStil)

{
    HWND hwnd;               /* This is the handle for our window */
    MSG messages;            /* Here messages to the application is saved */
    WNDCLASSEX wincl;        /* Datastructure for the windowclass */
    HMENU menu;              /* Handle of the menu */
    
    int FlagQuit=0;          /* flag  : quit application if !=0 */

    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;      /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Ctach double-clicks */
    wincl.cbSize = sizeof(WNDCLASSEX);

    /* Use default icon and mousepointer */
    wincl.hIcon = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon(NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor(NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL; /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use lightgray as the background of the window */
    wincl.hbrBackground = (HBRUSH) GetStockObject(LTGRAY_BRUSH);

    /* Register the window class, if fail quit the program */
    if(!RegisterClassEx(&wincl)) return 0;

    /* The class is registered, lets create the program*/
    hwnd = CreateWindowEx(
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           "RDS USB Coder",         /* Title Text */
           WS_OVERLAPPEDWINDOW, /* defaultwindow */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window end up on the screen */
           544,                 /* The programs width */
           375,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a childwindow to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

      /* initialise edit field */
      if (InitDataEdit()!=0)
	  {
   	        MessageBox (hwnd,"Error reading USB RDS coder board !","USB RDS coder",MB_ICONINFORMATION | MB_OK); 		   
	  }
      else
      {
         /* init OK, displaying dialog box */
         while (FlagQuit ==0)
         {
             if (DialogBox(hThisInstance, (LPCTSTR)IDD_DLG2, hwnd, (DLGPROC)MainDlg)  == IDC_QUIT)
             {
                FlagQuit=1;
             }
             else
             {
                /* reset , so close handler and reread all data*/
                usbCloseDevice(UsbRDSBoard);
                if (InitDataEdit()!=0)
	            {
   	                MessageBox (hwnd,"Error reading USB RDS coder board !","USB RDS coder",MB_ICONINFORMATION | MB_OK); 		   
   	                FlagQuit=1;
	            }
                

             }
         }
      }
    

    /* close device */
    usbCloseDevice(UsbRDSBoard);


    /* The program returvalue is 0 - The value that PostQuitMessage( ) gave */
    return messages.wParam;
}



// Mesage handler for RDSDialogPS box.
LRESULT CALLBACK RamPSDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
		{
           HWND hDlgString;
           hDlgString=GetDlgItem(hDlg,IDC_EDT1);   /* get dialog item for edit string */
           SetDlgItemText(hDlg,IDC_STC1,RdsUsbStringName);
           SetWindowText(hDlgString,RdsUsbStringParam);
           return TRUE;
        }

		case WM_COMMAND:
		
			switch (LOWORD(wParam))
			{
			case IDC_BTN1:
    			{
                    HWND hDlgString;
                    hDlgString=GetDlgItem(hDlg,IDC_EDT1);   /* get dialog item for edit string */
                    GetWindowText(hDlgString,RdsUsbStringParam,RDSUSB_SIZE_RTXT);
    
    				EndDialog(hDlg, LOWORD(wParam));
    				return TRUE;
    			}
 			case IDC_BTN2:
 			    EndDialog(hDlg, LOWORD(wParam));
 			    return TRUE;
            } 	
            break;		
        case WM_CLOSE:
            EndDialog(hDlg,IDC_BTN2);
            return TRUE;
	}
    return FALSE;
}



/* This function is called by the Windowsfunction DispatchMessage( ) */
LRESULT CALLBACK WindowProcedure(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)                  /* handle the messages */
    {
       case WM_COMMAND:
           switch( wParam )
           {
             case IDM_EDITRAM_PS:
             {
                strcpy(RdsUsbStringName,"RAM PS Name :");
                strcpy(RdsUsbStringParam,"TEST RDS");
                
                           
                if ( DialogBox(hThisInstance, (LPCTSTR)IDD_DLG1, hwnd, (DLGPROC)RamPSDlg) == IDC_BTN1)
                {
                    
                 /* debug edit string OK */
                 MessageBox( hwnd, RdsUsbStringParam,
                           (LPSTR) szClassName,
                           MB_ICONINFORMATION | MB_OK );
                           
                 }    
                  return 0;
             }
             
             
             case IDM_EDITRAM_RT:
                strcpy(RdsUsbStringName,"RAM RadioText :");
                strcpy(RdsUsbStringParam,"radiotext data");
            
             
//                if ( DialogBox(hThisInstance, (LPCTSTR)IDD_DLG1, hwnd, (DLGPROC)RamPSDlg) == IDC_BTN1)
                if ( DialogBox(hThisInstance, (LPCTSTR)IDD_DLG2, hwnd, (DLGPROC)MainDlg) == IDC_OK)
                {
                    
                 /* debug edit string OK */
                 MessageBox( hwnd, RdsUsbStringParam,
                           (LPSTR) szClassName,
                           MB_ICONINFORMATION | MB_OK );
                           
                 }    
                  return 0;
             case IDM_EDITRAM_PTY:
             case IDM_EDITRAM_TP:
             case IDM_EDITRAM_TA:
             case IDM_EDITRAM_MS:
             case IDM_EDITRAM_DI:
             case IDM_EDITEEP_PS:
             case IDM_EDITEEP_RT:
             case IDM_EDITEEP_PTY:
             case IDM_EDITEEP_TP:
             case IDM_EDITEEP_TA:
             case IDM_EDITEEP_MS:
             case IDM_EDITEEP_DI:
             case IDM_EDITEEP_PI:
             case IDM_EDITEEP_AF:
             case IDM_EDITCNF_STMONO:
             case IDM_EDITCNF_2A:
             case IDM_EDITCNF_VERSION:
             case IDM_EDITCNF_PING:
             case IDM_EDITCNF_RESET:
             case IDM_HELPCONTENTS:

                  MessageBox( hwnd, (LPSTR) "Function Not Yet Implemented.",
                              (LPSTR) szClassName,
                              MB_ICONINFORMATION | MB_OK );
                  DialogBox(hThisInstance, (LPCTSTR)IDD_DLG2, hwnd, (DLGPROC)MainDlg);
                  return 0;


             case IDM_FILEEXIT:
                  SendMessage( hwnd, WM_CLOSE, 0, 0L );
                  return 0;

             case IDM_HELPABOUT:
                  MessageBox (hwnd,
                   "RDS USB coder V1.2 07/2007 \r\nhttp://www.g.laroche.free.fr" ,
                   "RDS USB coder  version 1.2 ", 
                  MB_ICONINFORMATION | MB_OK);
                  return 0;

           }
           break;

      case WM_CLOSE:
           DestroyWindow( hwnd );
           return 0;

      case WM_DESTROY:
           PostQuitMessage (0);
           return 0;

      break;
      default:                   /* for messages that we don't deal with */
      return DefWindowProc(hwnd, message, wParam, lParam);
   }
  return 0;
}



