//    RDS PC software main file header
//
// =====================================================
//  Description
//    This file include main header
//       of RDS USB PC software using : AVR USB driver  by OBJECTIVE DEVELOPMENT Software GmbH 
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
//=======================================
// Author : G.Laroche www.g.laroche.free.fr
//=======================================
// History:
// 09/07/06    V1.0
//       create
//=======================================

#define NB_SIZE_DATA_EDIT_STRING 128   /* max string size for edit param dialog box */

typedef struct {
    int IdEdit;
    int IdRdsFunction;
    char OldString[NB_SIZE_DATA_EDIT_STRING];
    char NewString[NB_SIZE_DATA_EDIT_STRING];

} T_R_DataMainEdit;    /* struct edit param dialog box */

#define RDSUSB_SIZE_PSNAME 8
#define RDSUSB_SIZE_RTXT   64
#define RDSUSB_MAX_NBAF    25


#define ID_MENU 501

#define IDM_FILEEXIT        201

#define IDM_EDITRAM_PS      210
#define IDM_EDITRAM_RT      211
#define IDM_EDITRAM_PTY     212
#define IDM_EDITRAM_TP      213
#define IDM_EDITRAM_TA      214
#define IDM_EDITRAM_MS      215
#define IDM_EDITRAM_DI      216



#define IDM_EDITEEP_PS      220
#define IDM_EDITEEP_RT      221
#define IDM_EDITEEP_PTY     222
#define IDM_EDITEEP_TP      223
#define IDM_EDITEEP_TA      224
#define IDM_EDITEEP_MS      225
#define IDM_EDITEEP_DI      226
#define IDM_EDITEEP_PI      227
#define IDM_EDITEEP_AF      228


#define IDM_EDITCNF_STMONO  230
#define IDM_EDITCNF_2A      231
#define IDM_EDITCNF_VERSION 232
#define IDM_EDITCNF_PING    233
#define IDM_EDITCNF_RESET   234


#define IDM_HELPCONTENTS    240
#define IDM_HELPABOUT       241


/* RDSDialog box */
#define IDD_DLG1 2000
#define IDC_BTN1 2001
#define IDC_BTN2 2002
#define IDC_EDT1 2003
#define IDC_STC1 2004



#define IDD_DLG2 1000
#define IDC_STC2 1001
#define IDC_STC3 1002
#define IDC_EDTPS 1003
#define IDC_EDTRT 1004
#define IDC_STC4 1005
#define IDC_STC5 1006
#define IDC_EDTPTY 1007
#define IDC_STC6 1008
#define IDC_EDTTP 1009
#define IDC_EDTTA 1010
#define IDC_STC7 1011
#define IDC_OK 1012
#define IDC_CANCEL 1013
#define IDC_EDTMS 1014
#define IDC_STC8 1015
#define IDC_EDTDI 1016
#define IDC_STC9 1017
#define IDC_EDT_E2TA 1018
#define IDC_STC11 1019
#define IDC_EDT_E2TP 1020
#define IDC_STC12 1021
#define IDC_EDT_E2DI 1022
#define IDC_STC13 1023
#define IDC_EDT_E2MS 1024
#define IDC_STC14 1025
#define IDC_EDT_E2PTY 1026
#define IDC_STC15 1027
#define IDC_EDT_E2RT 1028
#define IDC_EDT_E2PS 1029
#define IDC_STC16 1030
#define IDC_STC17 1031
#define IDC_STC18 1032
#define IDC_EDT_E2PI 1033
#define IDC_STC10 1034
#define IDC_EDT_E2NAF 1035
#define IDC_STC19 1036
#define IDC_EDT_E2AF00 1037
#define IDC_STC20 1038
#define IDC_EDT_E2AF01 1039
#define IDC_STC21 1040
#define IDC_EDT_E2AF02 1041
#define IDC_STC22 1042
#define IDC_EDT_E2AF03 1043
#define IDC_STC23 1044
#define IDC_EDT_E2AF04 1045
#define IDC_STC24 1046
#define IDC_EDT_E2AF09 1047
#define IDC_STC25 1048
#define IDC_EDT_E2AF08 1049
#define IDC_STC26 1050
#define IDC_EDT_E2AF07 1051
#define IDC_STC27 1052
#define IDC_EDT_E2AF06 1053
#define IDC_STC28 1054
#define IDC_EDT_E2AF05 1055
#define IDC_STC29 1056
#define IDC_EDT_E2AF14 1057
#define IDC_STC30 1058
#define IDC_EDT_E2AF13 1059
#define IDC_STC31 1060
#define IDC_EDT_E2AF12 1061
#define IDC_STC32 1062
#define IDC_EDT_E2AF11 1063
#define IDC_STC33 1064
#define IDC_EDT_E2AF10 1065
#define IDC_STC34 1066
#define IDC_EDT_E2AF19 1067
#define IDC_STC35 1068
#define IDC_EDT_E2AF18 1069
#define IDC_STC36 1070
#define IDC_EDT_E2AF17 1071
#define IDC_STC37 1072
#define IDC_EDT_E2AF16 1073
#define IDC_STC38 1074
#define IDC_EDT_E2AF15 1075
#define IDC_STC39 1076
#define IDC_EDT_E2AF24 1077
#define IDC_STC40 1078
#define IDC_EDT_E2AF23 1079
#define IDC_STC41 1080
#define IDC_EDT_E2AF22 1081
#define IDC_STC42 1082
#define IDC_EDT_E2AF21 1083
#define IDC_STC43 1084
#define IDC_EDT_E2AF20 1085
#define IDC_STC44 1086
#define IDC_RESET 1087
#define IDC_QUIT 1088
#define IDC_HELPABOUT 1089
#define IDC_STC45 1090
#define IDC_STC46 1091
#define IDC_EDT2A 1092
#define IDC_EDT_E2STEREO 1093
#define IDC_STC47 1094



